import { Select } from "./applet/Init";
import { KeyName } from "./applet/Keyboard";
import { BindTests } from "./ecs/test";
import { Data } from "./game/GameComponents";
import { Main } from "./game/Main";
import { LoopbackServer } from "./net/LoopbackServer";

/* // Hot Module Reloading stub, if that's viable
 * declare const module: any;
 * if(module.hot) {
 *     const gen = module.hot.data?.gen ?? 0;
 *     module.hot.accept();
 *     module.hot.dispose((data: any) => {
 *         data.gen = gen + 1;
 *     });
 * }
 */

const server = new LoopbackServer<KeyName[], Data>();

Select(".GameCanvas").forEachCanvas((c, cx, keys) => new Main(c, cx, keys, server.socket));

BindTests();
